com.lowagie.text.pdf.codec

## Class Base64

- java.lang.Object
- - com.lowagie.text.pdf.codec.Base64

-     public class Base64
      extends java.lang.Object

  Encodes and decodes to and from Base64 notation.

  Homepage: http://iharder.net/base64.

  Change Log:

  - v2.2.1 - Fixed bug using URL_SAFE and ORDERED encodings. Fixed bug when using very small files (~< 40 bytes).
  - v2.2 - Added some helper methods for encoding/decoding directly from one file to the next. Also added a main() method to support command line encoding/decoding from one file to the next. Also added these Base64 dialects:
    1. The default is RFC3548 format.
    2. Calling Base64.setFormat(Base64.BASE64_FORMAT.URLSAFE_FORMAT) generates URL and file name friendly format as described in Section 4 of RFC3548. http://www.faqs.org/rfcs/rfc3548.html
    3. Calling Base64.setFormat(Base64.BASE64_FORMAT.ORDERED_FORMAT) generates URL and file name friendly format that preserves lexical ordering as described in http://www.faqs.org/qa/rfcc-1940.html
    Special thanks to Jim Kellerman at http://www.powerset.com/ for contributing the new Base64 dialects.
  - v2.1 - Cleaned up javadoc comments and unused variables and methods. Added some convenience methods for reading and writing to and from files.
  - v2.0.2 - Now specifies UTF-8 encoding in places where the code fails on systems with other encodings (like EBCDIC).
  - v2.0.1 - Fixed an error when decoding a single byte, that is, when the encoded data was a single byte.
  - v2.0 - I got rid of methods that used booleans to set options. Now everything is more consolidated and cleaner. The code now detects when data that's being decoded is gzip-compressed and will decompress it automatically. Generally things are cleaner. You'll probably have to change some method calls that you were making to support the new options format (`int`s that you "OR" together).
  - v1.5.1 - Fixed bug when decompressing and decoding to a byte[] using `decode( String s, boolean gzipCompressed )`. Added the ability to "suspend" encoding in the Output Stream so you can turn on and off the encoding if you need to embed base64 data in an otherwise "normal" stream (like an XML file).
  - v1.5 - Output stream pases on flush() command but doesn't do anything itself. This helps when using GZIP streams. Added the ability to GZip-compress objects before encoding them.
  - v1.4 - Added helper methods to read/write files.
  - v1.3.6 - Fixed OutputStream.flush() so that 'position' is reset.
  - v1.3.5 - Added flag to turn on and off line breaks. Fixed bug in input stream where last buffer being read, if not completely full, was not returned.
  - v1.3.4 - Fixed when "improperly padded stream" error was thrown at the wrong time.
  - v1.3.3 - Fixed I/O streams which were totally messed up.

  I am placing this code in the Public Domain. Do with it as you will. This software comes with no guarantees or warranties but with plenty of well-wishing instead! Please visit http://iharder.net/base64 periodically to check for updates or to contribute improvements.

  Version:
    2.2.1
  Author:
    Robert Harder, rob@iharder.net

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Base64.InputStream` A `Base64.InputStream` will read data from another `java.io.InputStream`, given in the constructor, and encode/decode to/from Base64 notation on the fly.
    `static class` | `Base64.OutputStream` A `Base64.OutputStream` will write data to another `java.io.OutputStream`, given in the constructor, and encode/decode to/from Base64 notation on the fly.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static byte[]` | `_ORDERED_ALPHABET` I don't get the point of this technique, but it is described here: http://www.faqs.org/qa/rfcc-1940.html.
    `private static byte[]` | `_ORDERED_DECODABET` Used in decoding the "ordered" dialect of Base64.
    `private static byte[]` | `_STANDARD_ALPHABET` The 64 valid Base64 values.
    `private static byte[]` | `_STANDARD_DECODABET` Translates a Base64 value to either its 6-bit reconstruction value or a negative number indicating some other meaning.
    `private static byte[]` | `_URL_SAFE_ALPHABET` Used in the URL- and Filename-safe dialect described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html.
    `private static byte[]` | `_URL_SAFE_DECODABET` Used in decoding URL- and Filename-safe dialects of Base64.
    `static int` | `DECODE` Specify decoding.
    `static int` | `DONT_BREAK_LINES` Don't break lines when encoding (violates strict Base64 specification)
    `static int` | `ENCODE` Specify encoding.
    `private static byte` | `EQUALS_SIGN` The equals sign (=) as a byte.
    `private static byte` | `EQUALS_SIGN_ENC`
    `static int` | `GZIP` Specify that data should be gzip-compressed.
    `private static int` | `MAX_LINE_LENGTH` Maximum line length (76) of Base64 output.
    `private static byte` | `NEW_LINE` The new line character (\n) as a byte.
    `static int` | `NO_OPTIONS` No options specified.
    `static int` | `ORDERED` Encode using the special "ordered" dialect of Base64 described here: http://www.faqs.org/qa/rfcc-1940.html.
    `private static java.lang.String` | `PREFERRED_ENCODING` Preferred encoding.
    `static int` | `URL_SAFE` Encode using Base64-like encoding that is URL- and Filename-safe as described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html.
    `private static byte` | `WHITE_SPACE_ENC`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `private` | `Base64()` Defeats instantiation.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static byte[]` | `decode(byte[] source, int off, int len, int options)` Very low-level access to decoding ASCII characters in the form of a byte array.
    `static byte[]` | `decode(java.lang.String s)` Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
    `static byte[]` | `decode(java.lang.String s, int options)` Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
    `private static int` | `decode4to3(byte[] source, int srcOffset, byte[] destination, int destOffset, int options)` Decodes four bytes from array source and writes the resulting bytes (up to three of them) to destination.
    `static void` | `decodeFileToFile(java.lang.String infile, java.lang.String outfile)` Reads `infile` and decodes it to `outfile`.
    `static byte[]` | `decodeFromFile(java.lang.String filename)` Convenience method for reading a base64-encoded file and decoding it.
    `static boolean` | `decodeToFile(java.lang.String dataToDecode, java.lang.String filename)` Convenience method for decoding data to a file.
    `static java.lang.Object` | `decodeToObject(java.lang.String encodedObject)` Attempts to decode Base64 data and deserialize a Java Object within.
    `private static byte[]` | `encode3to4(byte[] b4, byte[] threeBytes, int numSigBytes, int options)` Encodes up to the first three bytes of array threeBytes and returns a four-byte array in Base64 notation.
    `private static byte[]` | `encode3to4(byte[] source, int srcOffset, int numSigBytes, byte[] destination, int destOffset, int options)` Encodes up to three bytes of the array source and writes the resulting four Base64 bytes to destination.
    `static java.lang.String` | `encodeBytes(byte[] source)` Encodes a byte array into Base64 notation.
    `static java.lang.String` | `encodeBytes(byte[] source, int options)` Encodes a byte array into Base64 notation.
    `static java.lang.String` | `encodeBytes(byte[] source, int off, int len)` Encodes a byte array into Base64 notation.
    `static java.lang.String` | `encodeBytes(byte[] source, int off, int len, int options)` Encodes a byte array into Base64 notation.
    `static void` | `encodeFileToFile(java.lang.String infile, java.lang.String outfile)` Reads `infile` and encodes it to `outfile`.
    `static java.lang.String` | `encodeFromFile(java.lang.String filename)` Convenience method for reading a binary file and base64-encoding it.
    `static java.lang.String` | `encodeObject(java.io.Serializable serializableObject)` Serializes an object and returns the Base64-encoded version of that serialized object.
    `static java.lang.String` | `encodeObject(java.io.Serializable serializableObject, int options)` Serializes an object and returns the Base64-encoded version of that serialized object.
    `static boolean` | `encodeToFile(byte[] dataToEncode, java.lang.String filename)` Convenience method for encoding data to a file.
    `private static byte[]` | `getAlphabet(int options)` Returns one of the _SOMETHING_ALPHABET byte arrays depending on the options specified.
    `private static byte[]` | `getDecodabet(int options)` Returns one of the _SOMETHING_DECODABET byte arrays depending on the options specified.
    `static void` | `main(java.lang.String[] args)` Encodes or decodes two files from the command line; feel free to delete this method (in fact you probably should) if you're embedding this code into a larger program.
    `private static void` | `usage(java.lang.String msg)` Prints command line usage.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NO_OPTIONS

          public static final int NO_OPTIONS

      No options specified. Value is zero.
      See Also:
        Constant Field Values

    - #### ENCODE

          public static final int ENCODE

      Specify encoding.
      See Also:
        Constant Field Values

    - #### DECODE

          public static final int DECODE

      Specify decoding.
      See Also:
        Constant Field Values

    - #### GZIP

          public static final int GZIP

      Specify that data should be gzip-compressed.
      See Also:
        Constant Field Values

    - #### DONT_BREAK_LINES

          public static final int DONT_BREAK_LINES

      Don't break lines when encoding (violates strict Base64 specification)
      See Also:
        Constant Field Values

    - #### URL_SAFE

          public static final int URL_SAFE

      Encode using Base64-like encoding that is URL- and Filename-safe as described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html. It is important to note that data encoded this way is not officially valid Base64, or at the very least should not be called Base64 without also specifying that is was encoded using the URL- and Filename-safe dialect.
      See Also:
        Constant Field Values

    - #### ORDERED

          public static final int ORDERED

      Encode using the special "ordered" dialect of Base64 described here: http://www.faqs.org/qa/rfcc-1940.html.
      See Also:
        Constant Field Values

    - #### MAX_LINE_LENGTH

          private static final int MAX_LINE_LENGTH

      Maximum line length (76) of Base64 output.
      See Also:
        Constant Field Values

    - #### EQUALS_SIGN

          private static final byte EQUALS_SIGN

      The equals sign (=) as a byte.
      See Also:
        Constant Field Values

    - #### NEW_LINE

          private static final byte NEW_LINE

      The new line character (\n) as a byte.
      See Also:
        Constant Field Values

    - #### PREFERRED_ENCODING

          private static final java.lang.String PREFERRED_ENCODING

      Preferred encoding.
      See Also:
        Constant Field Values

    - #### WHITE_SPACE_ENC

          private static final byte WHITE_SPACE_ENC

      See Also:
        Constant Field Values

    - #### EQUALS_SIGN_ENC

          private static final byte EQUALS_SIGN_ENC

      See Also:
        Constant Field Values

    - #### _STANDARD_ALPHABET

          private static final byte[] _STANDARD_ALPHABET

      The 64 valid Base64 values.

    - #### _STANDARD_DECODABET

          private static final byte[] _STANDARD_DECODABET

      Translates a Base64 value to either its 6-bit reconstruction value or a negative number indicating some other meaning.

    - #### _URL_SAFE_ALPHABET

          private static final byte[] _URL_SAFE_ALPHABET

      Used in the URL- and Filename-safe dialect described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html. Notice that the last two bytes become "hyphen" and "underscore" instead of "plus" and "slash."

    - #### _URL_SAFE_DECODABET

          private static final byte[] _URL_SAFE_DECODABET

      Used in decoding URL- and Filename-safe dialects of Base64.

    - #### _ORDERED_ALPHABET

          private static final byte[] _ORDERED_ALPHABET

      I don't get the point of this technique, but it is described here: http://www.faqs.org/qa/rfcc-1940.html.

    - #### _ORDERED_DECODABET

          private static final byte[] _ORDERED_DECODABET

      Used in decoding the "ordered" dialect of Base64.

  - ### Constructor Detail

    - #### Base64

          private Base64()

      Defeats instantiation.

  - ### Method Detail

    - #### getAlphabet

          private static final byte[] getAlphabet(int options)

      Returns one of the _SOMETHING_ALPHABET byte arrays depending on the options specified. It's possible, though silly, to specify ORDERED and URLSAFE in which case one of them will be picked, though there is no guarantee as to which one will be picked.

    - #### getDecodabet

          private static final byte[] getDecodabet(int options)

      Returns one of the _SOMETHING_DECODABET byte arrays depending on the options specified. It's possible, though silly, to specify ORDERED and URL_SAFE in which case one of them will be picked, though there is no guarantee as to which one will be picked.

    - #### main

          public static final void main(java.lang.String[] args)

      Encodes or decodes two files from the command line; feel free to delete this method (in fact you probably should) if you're embedding this code into a larger program.

    - #### usage

          private static final void usage(java.lang.String msg)

      Prints command line usage.
      Parameters:
        `msg` - A message to include with usage info.

    - #### encode3to4

          private static byte[] encode3to4(byte[] b4,
                          byte[] threeBytes,
                          int numSigBytes,
                          int options)

      Encodes up to the first three bytes of array threeBytes and returns a four-byte array in Base64 notation. The actual number of significant bytes in your array is given by numSigBytes. The array threeBytes needs only be as big as numSigBytes. Code can reuse a byte array by passing a four-byte array as b4.
      Parameters:
        `b4` - A reusable byte array to reduce array instantiation
        `threeBytes` - the array to convert
        `numSigBytes` - the number of significant bytes in your array
      Returns:
        four byte array in Base64 notation.
      Since:
        1.5.1

    - #### encode3to4

          private static byte[] encode3to4(byte[] source,
                          int srcOffset,
                          int numSigBytes,
                          byte[] destination,
                          int destOffset,
                          int options)

      Encodes up to three bytes of the array source and writes the resulting four Base64 bytes to destination. The source and destination arrays can be manipulated anywhere along their length by specifying srcOffset and destOffset. This method does not check to make sure your arrays are large enough to accomodate srcOffset + 3 for the source array or destOffset + 4 for the destination array. The actual number of significant bytes in your array is given by numSigBytes.

      This is the lowest level of the encoding methods with all possible parameters.

      Parameters:
        `source` - the array to convert
        `srcOffset` - the index where conversion begins
        `numSigBytes` - the number of significant bytes in your array
        `destination` - the array to hold the conversion
        `destOffset` - the index where output will be put
      Returns:
        the destination array
      Since:
        1.3

    - #### encodeObject

          public static java.lang.String encodeObject(java.io.Serializable serializableObject)

      Serializes an object and returns the Base64-encoded version of that serialized object. If the object cannot be serialized or there is another error, the method will return `null`. The object is not GZip-compressed before being encoded.
      Parameters:
        `serializableObject` - The object to encode
      Returns:
        The Base64-encoded object
      Since:
        1.4

    - #### encodeObject

          public static java.lang.String encodeObject(java.io.Serializable serializableObject,
                                      int options)

      Serializes an object and returns the Base64-encoded version of that serialized object. If the object cannot be serialized or there is another error, the method will return `null`.

      Valid options:

             GZIP: gzip-compresses object before encoding it.
             DONT_BREAK_LINES: don't break lines at 76 characters
               Note: Technically, this makes your encoding non-compliant.

      Example: `encodeObject( myObj, Base64.GZIP )` or

      Example: `encodeObject( myObj, Base64.GZIP | Base64.DONT_BREAK_LINES )`

      Parameters:
        `serializableObject` - The object to encode
        `options` - Specified options
      Returns:
        The Base64-encoded object
      Since:
        2.0
      See Also:
        `GZIP`, `DONT_BREAK_LINES`

    - #### encodeBytes

          public static java.lang.String encodeBytes(byte[] source)

      Encodes a byte array into Base64 notation. Does not GZip-compress data.
      Parameters:
        `source` - The data to convert
      Since:
        1.4

    - #### encodeBytes

          public static java.lang.String encodeBytes(byte[] source,
                                     int options)

      Encodes a byte array into Base64 notation.

      Valid options:

             GZIP: gzip-compresses object before encoding it.
             DONT_BREAK_LINES: don't break lines at 76 characters
               Note: Technically, this makes your encoding non-compliant.

      Example: `encodeBytes( myData, Base64.GZIP )` or

      Example: `encodeBytes( myData, Base64.GZIP | Base64.DONT_BREAK_LINES )`

      Parameters:
        `source` - The data to convert
        `options` - Specified options
      Since:
        2.0
      See Also:
        `GZIP`, `DONT_BREAK_LINES`

    - #### encodeBytes

          public static java.lang.String encodeBytes(byte[] source,
                                     int off,
                                     int len)

      Encodes a byte array into Base64 notation. Does not GZip-compress data.
      Parameters:
        `source` - The data to convert
        `off` - Offset in array where conversion should begin
        `len` - Length of data to convert
      Since:
        1.4

    - #### encodeBytes

          public static java.lang.String encodeBytes(byte[] source,
                                     int off,
                                     int len,
                                     int options)

      Encodes a byte array into Base64 notation.

      Valid options:

             GZIP: gzip-compresses object before encoding it.
             DONT_BREAK_LINES: don't break lines at 76 characters
               Note: Technically, this makes your encoding non-compliant.

      Example: `encodeBytes( myData, Base64.GZIP )` or

      Example: `encodeBytes( myData, Base64.GZIP | Base64.DONT_BREAK_LINES )`

      Parameters:
        `source` - The data to convert
        `off` - Offset in array where conversion should begin
        `len` - Length of data to convert
        `options` - Specified options alphabet type is pulled from this (standard, url-safe, ordered)
      Since:
        2.0
      See Also:
        `GZIP`, `DONT_BREAK_LINES`

    - #### decode4to3

          private static int decode4to3(byte[] source,
                       int srcOffset,
                       byte[] destination,
                       int destOffset,
                       int options)

      Decodes four bytes from array source and writes the resulting bytes (up to three of them) to destination. The source and destination arrays can be manipulated anywhere along their length by specifying srcOffset and destOffset. This method does not check to make sure your arrays are large enough to accomodate srcOffset + 4 for the source array or destOffset + 3 for the destination array. This method returns the actual number of bytes that were converted from the Base64 encoding.

      This is the lowest level of the decoding methods with all possible parameters.

      Parameters:
        `source` - the array to convert
        `srcOffset` - the index where conversion begins
        `destination` - the array to hold the conversion
        `destOffset` - the index where output will be put
        `options` - alphabet type is pulled from this (standard, url-safe, ordered)
      Returns:
        the number of decoded bytes converted
      Since:
        1.3

    - #### decode

          public static byte[] decode(byte[] source,
                      int off,
                      int len,
                      int options)

      Very low-level access to decoding ASCII characters in the form of a byte array. Does not support automatically gunzipping or any other "fancy" features.
      Parameters:
        `source` - The Base64 encoded data
        `off` - The offset of where to begin decoding
        `len` - The length of characters to decode
      Returns:
        decoded data
      Since:
        1.3

    - #### decode

          public static byte[] decode(java.lang.String s)

      Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
      Parameters:
        `s` - the string to decode
      Returns:
        the decoded data
      Since:
        1.4

    - #### decode

          public static byte[] decode(java.lang.String s,
                      int options)

      Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
      Parameters:
        `s` - the string to decode
        `options` - encode options such as URL_SAFE
      Returns:
        the decoded data
      Since:
        1.4

    - #### decodeToObject

          public static java.lang.Object decodeToObject(java.lang.String encodedObject)

      Attempts to decode Base64 data and deserialize a Java Object within. Returns `null` if there was an error.
      Parameters:
        `encodedObject` - The Base64 data to decode
      Returns:
        The decoded and deserialized object
      Since:
        1.5

    - #### encodeToFile

          public static boolean encodeToFile(byte[] dataToEncode,
                             java.lang.String filename)

      Convenience method for encoding data to a file.
      Parameters:
        `dataToEncode` - byte array of data to encode in base64 form
        `filename` - Filename for saving encoded data
      Returns:
        `true` if successful, `false` otherwise
      Since:
        2.1

    - #### decodeToFile

          public static boolean decodeToFile(java.lang.String dataToDecode,
                             java.lang.String filename)

      Convenience method for decoding data to a file.
      Parameters:
        `dataToDecode` - Base64-encoded data as a string
        `filename` - Filename for saving decoded data
      Returns:
        `true` if successful, `false` otherwise
      Since:
        2.1

    - #### decodeFromFile

          public static byte[] decodeFromFile(java.lang.String filename)

      Convenience method for reading a base64-encoded file and decoding it.
      Parameters:
        `filename` - Filename for reading encoded data
      Returns:
        decoded byte array or null if unsuccessful
      Since:
        2.1

    - #### encodeFromFile

          public static java.lang.String encodeFromFile(java.lang.String filename)

      Convenience method for reading a binary file and base64-encoding it.
      Parameters:
        `filename` - Filename for reading binary data
      Returns:
        base64-encoded string or null if unsuccessful
      Since:
        2.1

    - #### encodeFileToFile

          public static void encodeFileToFile(java.lang.String infile,
                              java.lang.String outfile)

      Reads `infile` and encodes it to `outfile`.
      Parameters:
        `infile` - Input file
        `outfile` - Output file
      Since:
        2.2

    - #### decodeFileToFile

          public static void decodeFileToFile(java.lang.String infile,
                              java.lang.String outfile)

      Reads `infile` and decodes it to `outfile`.
      Parameters:
        `infile` - Input file
        `outfile` - Output file
      Since:
        2.2